#!/usr/bin/perl

use strict;
use warnings;

open(my $plik, "<", "Bible.txt");
my @lines=<$plik>;
close $plik;

my %pojedyncze;
my $ilosc = 0;

print "Counting...\n";
my $calosc = join(' ', @lines);
$calosc =~ s{[\W\d]}{ }g;
$calosc = lc $calosc;
my @wszystkie = split(' ', $calosc);
foreach my $word (@wszystkie) {
	if (length $word > 1 or $word eq "i" or $word eq "a") {
		$pojedyncze{$word}++;
		$ilosc++;
	}
}

print "All words: " . $ilosc . "\n"; 
print "Unique words: " . keys(%pojedyncze) . "\n"; 
print "Sorting and writing results to the file...\n";

open(my $slowa, ">", "words.txt");
print $slowa "Total number of words: " . $ilosc . ".\n";
print $slowa "Number of unique words  " . keys(%pojedyncze) . ".\n\n";
foreach my $word (sort { $pojedyncze{$b} <=> $pojedyncze{$a} } keys %pojedyncze) {
	print $slowa "$word - $pojedyncze{$word}\n";
}
close $slowa;

print "Done!\n";
