set plik [open "Bible.txt" r]
set calosc [read $plik]
close $plik

puts "Counting..."

regsub -all {[^a-zA-Z]} $calosc " " calosc
set calosc [string tolower $calosc]

set wszystkie [split $calosc " "]
foreach line $wszystkie {
	if {[string length $line] > 1 || $line eq "a" || $line eq "i"} {
		incr x
		if {[info exists unikalne($line)]} {
			set unikalne($line) [expr {$unikalne($line) + 1}]
		} else {
			set unikalne($line) 1
			incr y
		}
	}
}

puts "All words: $x"
puts "Unique words: $y"

foreach slowo [lsort [array names unikalne]] {
    set wartosci($unikalne($slowo)) 1
}

foreach liczba [lsort [array names wartosci]] {
	lappend ilosci $liczba
}

puts "Sorting by occurence and writing to the file..."
set plik [open "words.txt" w]
puts $plik "All words: $x"
puts $plik "Unique words: $y\n"

foreach z [lsort -integer $ilosci] {
	foreach slowo [array names unikalne] {
		if {$unikalne($slowo) == $z} {
			puts $plik "$slowo - $unikalne($slowo)"
			unset unikalne($slowo)
		}
	}
}
close $plik

puts "Done!"
